#ifndef TYFC_H
#define TYFC_H

#include <windows.h>
#include <vector>
#include <list>
#include <shape.h>

extern "C" int WINAPI WinMain(HINSTANCE, HINSTANCE,PSTR, int);
extern "C" LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);

const int maxshapes = 100;

class TYFCApp	{
    HWND hwnd;		// window handle of app
    const char* title;
    int width, height;	// window size
    HDC hdc;
    PAINTSTRUCT ps;
    std::list<Shape*> shapes;
	friend int WINAPI WinMain(HINSTANCE, HINSTANCE,PSTR, int);
    friend LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
    virtual void Initialize() { }
    void drawshapes();
	COLORREF Windowscolor(Color color) const;
public:
	static TYFCApp* theApp;
    TYFCApp(const char* ttl, int wd = CW_USEDEFAULT, int ht = CW_USEDEFAULT);
    virtual ~TYFCApp() { }
    void addshape(Shape& shape);
    void drawpoint(int x, int y, Color color = black);
    int Width() const { return width; }
    int Height() const { return height; }
	HDC Hdc() const { return hdc; }
    int adjx(int x) const
        { return x + width/2; }
    int adjy(int y) const
        { return y + height/2; }
};

#endif  // #ifndef TYFC_H
