// ----- circle.h

#ifndef CIRCLE_H
#define CIRCLE_H
#include <graphics.h>

namespace GraphicsLibrary  {

template <class T>
class Circle : public TShape<T>  {
    int radius;
	void draw8points(int x, int y);
	void draw4points(int x, int y);
public:
    Circle(T& t, int x, int y, int rd, Color clr = black) :
			TShape<T>(&t, x, y, clr), radius(rd)
    {  }
    Circle(T& t, Point center, int rd, Color clr = black) : 
			TShape<T>(&t, center, clr), radius(rd)
    {  }
    virtual void draw();
};
template <class T>
inline void Circle<T>::draw4points(int x, int y)
{
	drawpoint( x,  y);
	drawpoint(-x,  y);
	drawpoint( x, -y);
	drawpoint(-x, -y);
}
template <class T>
inline void Circle<T>::draw8points(int x, int y)
{
	draw4points(x, y);
	draw4points(y, x);
}
template <class T>
void Circle<T>::draw()
{
	if (radius > 0)	{
		int x = 0, y = radius;
		int d = 1 - radius;
		int d1 = 3, d2 = -2 * radius + 5;
		do	{
			draw8points(x, y);
			if (d < 0)	{
				d += d1;
				d2 += 2;
			}
			else	{
				d += d2;
				d2 += 4;
				--y;
			}
			d1 += 2;
		} while (y > x++);
	}
}

} // namespace GraphicsLibrary

#endif