// ------- polygon.h
#ifndef POLYGON_H
#define POLYGON_H
#include <polyline.h>

namespace GraphicsLibrary  {

template <class T>
class Polygon : public Polyline<T>  {
public:
    Polygon(T& t, Point pos, std::vector<Point> verts, Color clr = black) : 
				Polyline<T>(t, pos, verts, clr)
	    {  }
    Polygon(T& t, Point pos, Color clr) : Polyline<T>(t, pos, clr)
    	{  }
    virtual void draw();
};
template <class T>
void Polygon<T>::draw()
{
	if (vertices.size() > 0)	{
		// --- add the final, connecting vertex
		addvertex(*vertices.begin());
		Polyline<T>::draw();
	}
}

} // namespace GraphicsLibrary

#endif