// ------ rectangle.h

#ifndef RECTANGLE_H
#define RECTANGLE_H
#include <polygon.h>

namespace GraphicsLibrary  {

template <class T>
class Rectangle : public Polygon<T>  {
	int height, width;
	void buildrectangle();
public:
	Rectangle(T& t, int x, int y, int ht, int wd, Color clr = black) :
			Polygon<T>(t, Point(x, y), clr), height(ht), width(wd)
	    { buildrectangle(); }
	Rectangle(T& t, Point pos, int ht, int wd, Color clr = black) :
			Polygon<T>(t, pos, clr), height(ht), width(wd)
	   	{ buildrectangle(); }
	virtual void draw();
};
template <class T>
void Rectangle<T>::buildrectangle()
{
	addvertex(Point(0,0));
	addvertex(Point(width-1,0));
	addvertex(Point(width-1,height-1));
	addvertex(Point(0,height-1));
}
// ---- redundant function declaration supports specializations
template <class T>
void Rectangle<T>::draw()
{
	Polygon<T>::draw();
}

} // namespace GraphicsLibrary

#endif