/*
 * Author: Andrew D. Fernandes <mailto:andrew@cryptonym.com>
 *         Cryptonym Corporation <http://www.cryptonym.com>
 */

#ifndef affine_h
#define affine_h


#include "mpi-extra.h"


typedef struct aPoint {
  MPI x, y;
} apoint;


extern apoint aP;     /* the base point */

extern int debug;

void init_apoint();
void fini_apoint();
apoint apoint_alloc();
void apoint_free(apoint p);
void apoint_double(apoint y, apoint x);
void apoint_add(apoint z, apoint x, apoint y);
void apoint_scalar_multiply(apoint ge, apoint g, MPI e);


#endif
