/*
 * Author: Andrew D. Fernandes <mailto:andrew@cryptonym.com>
 *         Cryptonym Corporation <http://www.cryptonym.com>
 */

#include <mpi.h>
#include <stdlib.h>

extern int debug;
extern int mode;

#if ECDSA_TYPE == 0
  #define EC_TYPE "affine"
#elif ECDSA_TYPE == 1
  #define EC_TYPE "projective"
#else
  #error ECDSA_TYPE must be 0 (affine) or 1 (projective)
#endif

void init_ecdsa();
void fini_ecdsa();
void ecdsa_generate_special(MPI k);
void ecdsa_sign(MPI h, MPI r, MPI s);
int ecdsa_verify(MPI h, MPI r, MPI s);
