/* FILE        : hash.h
** AUTHOR      : Jim Shapiro
** DATE        : 19 March, 1999
** DISCLAIMER  : No liability is assumed by the author for any use
**               made of this program.
** DISTRIBUTION: Any use may be made of this program, as long as the
**               clear acknowledgment is made to the author in code
**               and runtime executables.  The author retains
**               copyright.
*/

#ifdef THIS_IS_MAIN
#define GLOBAL
GLOBAL int Primes[] = { 101, 1009, 10007, 100003 };
#define EQ(x) = x
#else
#define GLOBAL extern
GLOBAL int Primes[];
#define EQ(x)
#endif

typedef enum { FALSE, TRUE } BOOLEAN;
typedef enum { DUPLICATE_KEY, INSERT_OK } INSERT_STATUS;

enum { SMALL_HASH, MEDIUM_HASH, LARGE_HASH, XLARGE_HASH };

typedef struct _cb_node
{ /* char *key - BOOLEAN value */
  char *key;
  BOOLEAN value;
  struct _cb_node *next;
} CB_NODE;

GLOBAL CB_NODE ***Cb_heads_ppp;
GLOBAL CB_NODE Cb_tail;   /* Can use same tail for all hashes. */
GLOBAL int     *Cb_sizes; /* Contains sizes of each hash. */

void initialize_cb_hash_count(int count);
void initialize_cb_hash_size(int h, int size);
void initialize_cb_hashes(int count);
INSERT_STATUS cb_new_pair(int h, char *key, BOOLEAN value);
BOOLEAN cb_exists(int h, char *key);
