#include <tyfc.h>
#include <vector>
#include <line.h>
#include <specialize.h>

namespace GL = GraphicsLibrary;

class Pattern : public TYFCApp  {
	std::vector<GL::Line<TYFCApp> > lines;
	static const int degs = 15;
	static const int dim = 300;
	static const int radius = (dim-30)/2;
public:
    Pattern() : TYFCApp("Graphics", dim, dim)
    {  }
    void Initialize();
};
static Pattern pattern;

void Pattern::Initialize()
{
    const double pi = 3.1415927;
    for (int ang = 0; ang < 360; ang += degs)  {
        double radang = ang * pi / 180.0;
        int x1 = static_cast<int>(radius * std::cos(radang));
        int y1 = static_cast<int>(radius * std::sin(radang));
		static Color cols[] = { red, green, blue, magenta, cyan, yellow };
		Color color = cols[(ang/degs) % 6];
	    for (int ang1 = ang + degs; ang1 < 360; ang1 += degs)  {
	        double radang1 = ang1 * pi / 180.0;
    	    int x2 = static_cast<int>(radius * std::cos(radang1));
        	int y2 = static_cast<int>(radius * std::sin(radang1));
			GL::Line<TYFCApp> ln(pattern, x1,y1,x2,y2, color);
			lines.push_back(ln);
		}
    }
	std::vector<GL::Line<TYFCApp> >::iterator iter;
	for (iter = lines.begin(); iter < lines.end(); iter++)
		addshape(*iter);
}

