/*
 * Author: Andrew D. Fernandes <mailto:andrew@cryptonym.com>
 *         Cryptonym Corporation <http://www.cryptonym.com>
 */

#ifndef projective_h
#define projective_h


#include "mpi-extra.h"


typedef struct pPoint {
  MPI x, y, z;
} ppoint;


extern ppoint pP;     /* the base point */

extern int debug;

void init_ppoint();
void fini_ppoint();
ppoint ppoint_alloc();
void ppoint_free(ppoint p);
void ppoint_double(ppoint y, ppoint x);
void ppoint_add(ppoint z, ppoint x, ppoint y);
void ppoint_scalar_multiply(ppoint ge, ppoint g, MPI e);
void normalize_ppoint(ppoint p);

#endif
