#include <tyfc.h>
#include <circle.h>
#include <rectangle.h>
#include <line.h>
#include <polygon.h>
//#include <specialize.h>

namespace GL = GraphicsLibrary;

class GApp : public TYFCApp  {
	GL::Circle<TYFCApp>    circle;
	GL::Rectangle<TYFCApp> rectangle;
	GL::Line<TYFCApp>      line;
	GL::Polygon<TYFCApp>   polygon;
public:
	GApp();
    void Initialize();
};

GApp::GApp() : TYFCApp("Graphics", 400, 350),
				rectangle(*this,  -50,  -55,  80, 95, blue),
				circle   (*this,   50,  -15,  120,    red),
				line     (*this, -110, -100, 122, 43, green),
				polygon  (*this, GL::Point(-50,20),   magenta)
{
	static GL::Point pts[] = {
		GL::Point(-30,-30),
		GL::Point(-10,-40),
		GL::Point(-30,-30),
		GL::Point(-10,-40),
		GL::Point(50,-35),
		GL::Point(70,-10),
		GL::Point(65,20),
		GL::Point(10,15),
		GL::Point(-25,60),
		GL::Point(-37,20)
	};
	for (int i = 0; i < sizeof(pts) / sizeof(GL::Point); i++)
		polygon.addvertex(pts[i]);
}

void GApp::Initialize()
{
	addshape(circle);
	addshape(rectangle);
	addshape(polygon);
	addshape(line);
}

static GApp app;

